#!/bin/bash
#add build-nr
build=$(cat build)
sed "s/######/${build}/g" src/main.asm > tmp/main.asm
build=$((build+1))
echo $build > build
echo "Build-Nummer aktualisiert.";
#compile
echo "Wandle boot.asm in boot.bin um...";
nasm src/boot.asm -o tmp/boot.bin
echo "Fertig.";
echo "Wandle main.asm in main.bin um...";
nasm tmp/main.asm -o tmp/main.bin
echo "Fertig.";


#connect
echo "Erstelle .img Image...";
cat tmp/boot.bin tmp/main.bin > out/os.img

echo "Vorgang beendet";
virtualbox --startvm own

